<?php

//формируем случайные данные для наполнения блока
function getRandomData() {
    $authors = ['bob', 'jack', 'tom', 'jane', 'rose', 'liam', 'hugo', 'amber', 'faith', 'zara', 'alex', 'jude'];
    shuffle($authors);
    $author = $authors[0];

    $data = json_encode(['data' => 'Random string ' . strrev($authors[5]), 'custom_data' => 'Random number ' . rand()]);

    $timestamp = time();

    return [
        'author' => $author,
        'data' => $data,
        'timestamp' => $timestamp,
    ];
}

//находим хэш последнего блока
function getLastHash() {
    global $db;
    //для первого блока хэш будет пустым
    $last_hash = '';

    //тянем hash последней записи
    $sql = "select hash from `blocks` order by id desc limit 1";
    $sth = $db->prepare($sql);
    $sth->execute();
    $res = $sth->fetch();
    if (!empty($res['hash'])) {
        $last_hash = $res['hash'];
    }

    return $last_hash;
}

//формирование хэша блока
function createBlockHash($author, $data, $timestamp, $last_hash) {
    // формируем хэш блока, исходя из автора, данных, времени и хэша предыдущего блока
    $block_hash = hash('sha256', json_encode([$author, $data, (int) $timestamp, $last_hash]));
    return $block_hash;
}

//создание блока
function insertNewBlock($author, $data, $timestamp, $block_hash) {
    global $db;
    $sql = "insert into `blocks` (`author`, `data`, `timestamp`, `hash`) values (:author, :data, :timestamp, :hash)";
    $sth = $db->prepare($sql);
    $sth->bindValue(':author', $author);
    $sth->bindValue(':data', $data);
    $sth->bindValue(':timestamp', $timestamp);
    $sth->bindValue(':hash', $block_hash);
    $sth->execute();
    $id = $db->lastInsertId();
    return $id;
}