<?php

//находим hash и id последнего блока. считаем "часть" блоков
function getLastBlock() {
    global $db;

    //для первого блока hash будет пустым и id = 0
    $last_hash = '';
    $last_block_id = 0;

    //тянем hash и id последнего блока
    $sql = "select * from `mining` order by id desc limit 1";
    $sth = $db->prepare($sql);
    $sth->execute();
    $res = $sth->fetch();
    if (!empty($res['hash'])) {
        $last_hash = $res['hash'];
        $last_block_id = $res['id'];
    }

    // определяем к какой "части" относится блок
    $part = (int)(($last_block_id + 10) / 10);

    return [
        'last_hash' => $last_hash,
        'last_block_id' => $last_block_id,
        'part' => $part
    ];
}

// перебор хэшей и проверка - удовлетворяет ли он условиям блокчейна
function mining($part, $last_hash, $start = 0, $limit = 30000) {
    $finish = $start + $limit;

    while($start < $finish) {
        if ($part > 9) {
            echo 'Blockchain full<br />';
            break;
        }
        $start++;

        //формируем случайный хэш
        $hash = generateMiningHash();

        //хэшируем последний хэш и свежесформированный
        $new_hash = hash('sha256', $last_hash . $hash);

        //проверяем - удовлетворяет ли сформированный хэш условиям блокчейна
        $check = checkHash($new_hash, $part);

        if ($check == true) {
            // блок найден
            echo 'Block found<br />';
            echo '$hash = ' . $hash .'<br>';
            echo '$new_hash = ' . $new_hash .'<br>';
            // сохраняем в таблицу
            insertMinedBlock($hash, $start);
            echo '<meta http-equiv="refresh" content="1;?start=0">';
            break;
        } else {
            //блок не найден
            echo '<meta http-equiv="refresh" content="1;?start=' . $start . '">';
        }
    }
    echo 'Checked ' . $start . ' hashes';
}


//создание блока
function insertMinedBlock($hash, $counts) {
    global $db;
    $sql = "insert into `mining` (`hash`, `counts`) values (:hash, :counts)";
    $sth = $db->prepare($sql);
    $sth->bindValue(':hash', $hash);
    $sth->bindValue(':counts', $counts);
    $sth->execute();
}

// проверка удовлетворяет ли хэш условиям блокчейна
function checkHash($hash, $part) {
    // разбиваем строку на символы
    $symbols = str_split($hash);
    $check = true;
    $ver = 1;
    while ($ver <= $part) {
        // для каждой "части" проверяем количество нужных символов
        $ver_count = $ver;
        foreach ($symbols as $symbol) {
            if ($symbol == $ver) {
                $ver_count--;
            }
        }
        if ($ver_count != 0) {
            // если все правила "части" выполнены - $check останется равным true
            $check = false;
        }
        $ver++;
    }
    return $check;
}

//формирование рандомного хэша
function generateMiningHash() {
    return hash('sha256', rand());
}